Bug 1926612 - python-murano-pkg-check fails to build with Python 3.10: AttributeError: module 'collections' has no attribute 'Sequence'
Summary: python-murano-pkg-check fails to build with Python 3.10: AttributeError: modu...
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: python-murano-pkg-check
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Javier Peña
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
: 1969040 (view as bug list)
Depends On: 1969311
Blocks: F35FTBFS F35FailsToInstall PYTHON3.10
TreeView+ depends on / blocked
 
Reported: 2021-02-09 08:18 UTC by Tomáš Hrnčiar
Modified: 2021-06-16 08:45 UTC (History)
5 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2021-06-16 08:45:25 UTC
Type: Bug


Attachments (Terms of Use)

Description Tomáš Hrnčiar 2021-02-09 08:18:38 UTC
python-murano-pkg-check fails to build with Python 3.10.0a5.

Traceback (most recent call last):
  File "/usr/lib64/python3.10/unittest/loader.py", line 436, in _find_test_path
    module = self._get_module_from_name(name)
  File "/usr/lib64/python3.10/unittest/loader.py", line 377, in _get_module_from_name
    __import__(name)
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/tests/functional/test_cases.py", line 24, in <module>
    from muranopkgcheck import manager
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/manager.py", line 29, in <module>
    from muranopkgcheck.validators import VALIDATORS
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/validators/__init__.py", line 16, in <module>
    from muranopkgcheck.validators import muranopl
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/validators/muranopl.py", line 19, in <module>
    from muranopkgcheck.checkers import code_structure
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/checkers/code_structure.py", line 18, in <module>
    from muranopkgcheck.checkers import yaql_checker
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/checkers/yaql_checker.py", line 15, in <module>
    import yaql
  File "/usr/lib/python3.10/site-packages/yaql/__init__.py", line 18, in <module>
    from yaql.language import contexts
  File "/usr/lib/python3.10/site-packages/yaql/language/contexts.py", line 20, in <module>
    from yaql.language import runner
  File "/usr/lib/python3.10/site-packages/yaql/language/runner.py", line 20, in <module>
    from yaql.language import expressions
  File "/usr/lib/python3.10/site-packages/yaql/language/expressions.py", line 21, in <module>
    from yaql.language import utils
  File "/usr/lib/python3.10/site-packages/yaql/language/utils.py", line 54, in <module>
    SequenceType = collections.Sequence
AttributeError: module 'collections' has no attribute 'Sequence'

Failed to import test module: muranopkgcheck.tests.test_code_structure_checker
Traceback (most recent call last):
  File "/usr/lib64/python3.10/unittest/loader.py", line 436, in _find_test_path
    module = self._get_module_from_name(name)
  File "/usr/lib64/python3.10/unittest/loader.py", line 377, in _get_module_from_name
    __import__(name)
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/tests/test_code_structure_checker.py", line 17, in <module>
    from muranopkgcheck.checkers import code_structure
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/checkers/code_structure.py", line 18, in <module>
    from muranopkgcheck.checkers import yaql_checker
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/checkers/yaql_checker.py", line 15, in <module>
    import yaql
  File "/usr/lib/python3.10/site-packages/yaql/__init__.py", line 18, in <module>
    from yaql.language import contexts
  File "/usr/lib/python3.10/site-packages/yaql/language/contexts.py", line 20, in <module>
    from yaql.language import runner
  File "/usr/lib/python3.10/site-packages/yaql/language/runner.py", line 20, in <module>
    from yaql.language import expressions
  File "/usr/lib/python3.10/site-packages/yaql/language/expressions.py", line 21, in <module>
    from yaql.language import utils
  File "/usr/lib/python3.10/site-packages/yaql/language/utils.py", line 54, in <module>
    SequenceType = collections.Sequence
AttributeError: module 'collections' has no attribute 'Sequence'

Failed to import test module: muranopkgcheck.tests.test_manager
Traceback (most recent call last):
  File "/usr/lib64/python3.10/unittest/loader.py", line 436, in _find_test_path
    module = self._get_module_from_name(name)
  File "/usr/lib64/python3.10/unittest/loader.py", line 377, in _get_module_from_name
    __import__(name)
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/tests/test_manager.py", line 18, in <module>
    from muranopkgcheck import manager
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/manager.py", line 29, in <module>
    from muranopkgcheck.validators import VALIDATORS
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/validators/__init__.py", line 16, in <module>
    from muranopkgcheck.validators import muranopl
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/validators/muranopl.py", line 19, in <module>
    from muranopkgcheck.checkers import code_structure
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/checkers/code_structure.py", line 18, in <module>
    from muranopkgcheck.checkers import yaql_checker
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/checkers/yaql_checker.py", line 15, in <module>
    import yaql
  File "/usr/lib/python3.10/site-packages/yaql/__init__.py", line 18, in <module>
    from yaql.language import contexts
  File "/usr/lib/python3.10/site-packages/yaql/language/contexts.py", line 20, in <module>
    from yaql.language import runner
  File "/usr/lib/python3.10/site-packages/yaql/language/runner.py", line 20, in <module>
    from yaql.language import expressions
  File "/usr/lib/python3.10/site-packages/yaql/language/expressions.py", line 21, in <module>
    from yaql.language import utils
  File "/usr/lib/python3.10/site-packages/yaql/language/utils.py", line 54, in <module>
    SequenceType = collections.Sequence
AttributeError: module 'collections' has no attribute 'Sequence'

Failed to import test module: muranopkgcheck.tests.test_manifest_validator
Traceback (most recent call last):
  File "/usr/lib64/python3.10/unittest/loader.py", line 436, in _find_test_path
    module = self._get_module_from_name(name)
  File "/usr/lib64/python3.10/unittest/loader.py", line 377, in _get_module_from_name
    __import__(name)
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/tests/test_manifest_validator.py", line 19, in <module>
    from muranopkgcheck.validators import manifest
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/validators/__init__.py", line 16, in <module>
    from muranopkgcheck.validators import muranopl
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/validators/muranopl.py", line 19, in <module>
    from muranopkgcheck.checkers import code_structure
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/checkers/code_structure.py", line 18, in <module>
    from muranopkgcheck.checkers import yaql_checker
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/checkers/yaql_checker.py", line 15, in <module>
    import yaql
  File "/usr/lib/python3.10/site-packages/yaql/__init__.py", line 18, in <module>
    from yaql.language import contexts
  File "/usr/lib/python3.10/site-packages/yaql/language/contexts.py", line 20, in <module>
    from yaql.language import runner
  File "/usr/lib/python3.10/site-packages/yaql/language/runner.py", line 20, in <module>
    from yaql.language import expressions
  File "/usr/lib/python3.10/site-packages/yaql/language/expressions.py", line 21, in <module>
    from yaql.language import utils
  File "/usr/lib/python3.10/site-packages/yaql/language/utils.py", line 54, in <module>
    SequenceType = collections.Sequence
AttributeError: module 'collections' has no attribute 'Sequence'

Failed to import test module: muranopkgcheck.tests.test_muranopl_validator
Traceback (most recent call last):
  File "/usr/lib64/python3.10/unittest/loader.py", line 436, in _find_test_path
    module = self._get_module_from_name(name)
  File "/usr/lib64/python3.10/unittest/loader.py", line 377, in _get_module_from_name
    __import__(name)
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/tests/test_muranopl_validator.py", line 19, in <module>
    from muranopkgcheck.validators import muranopl
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/validators/__init__.py", line 16, in <module>
    from muranopkgcheck.validators import muranopl
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/validators/muranopl.py", line 19, in <module>
    from muranopkgcheck.checkers import code_structure
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/checkers/code_structure.py", line 18, in <module>
    from muranopkgcheck.checkers import yaql_checker
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/checkers/yaql_checker.py", line 15, in <module>
    import yaql
  File "/usr/lib/python3.10/site-packages/yaql/__init__.py", line 18, in <module>
    from yaql.language import contexts
  File "/usr/lib/python3.10/site-packages/yaql/language/contexts.py", line 20, in <module>
    from yaql.language import runner
  File "/usr/lib/python3.10/site-packages/yaql/language/runner.py", line 20, in <module>
    from yaql.language import expressions
  File "/usr/lib/python3.10/site-packages/yaql/language/expressions.py", line 21, in <module>
    from yaql.language import utils
  File "/usr/lib/python3.10/site-packages/yaql/language/utils.py", line 54, in <module>
    SequenceType = collections.Sequence
AttributeError: module 'collections' has no attribute 'Sequence'

Failed to import test module: muranopkgcheck.tests.test_package
Traceback (most recent call last):
  File "/usr/lib64/python3.10/unittest/loader.py", line 436, in _find_test_path
    module = self._get_module_from_name(name)
  File "/usr/lib64/python3.10/unittest/loader.py", line 377, in _get_module_from_name
    __import__(name)
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/tests/test_package.py", line 19, in <module>
    from muranopkgcheck.validators import package
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/validators/__init__.py", line 16, in <module>
    from muranopkgcheck.validators import muranopl
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/validators/muranopl.py", line 19, in <module>
    from muranopkgcheck.checkers import code_structure
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/checkers/code_structure.py", line 18, in <module>
    from muranopkgcheck.checkers import yaql_checker
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/checkers/yaql_checker.py", line 15, in <module>
    import yaql
  File "/usr/lib/python3.10/site-packages/yaql/__init__.py", line 18, in <module>
    from yaql.language import contexts
  File "/usr/lib/python3.10/site-packages/yaql/language/contexts.py", line 20, in <module>
    from yaql.language import runner
  File "/usr/lib/python3.10/site-packages/yaql/language/runner.py", line 20, in <module>
    from yaql.language import expressions
  File "/usr/lib/python3.10/site-packages/yaql/language/expressions.py", line 21, in <module>
    from yaql.language import utils
  File "/usr/lib/python3.10/site-packages/yaql/language/utils.py", line 54, in <module>
    SequenceType = collections.Sequence
AttributeError: module 'collections' has no attribute 'Sequence'

Failed to import test module: muranopkgcheck.tests.test_plugin
Traceback (most recent call last):
  File "/usr/lib64/python3.10/unittest/loader.py", line 436, in _find_test_path
    module = self._get_module_from_name(name)
  File "/usr/lib64/python3.10/unittest/loader.py", line 377, in _get_module_from_name
    __import__(name)
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/tests/test_plugin.py", line 17, in <module>
    from muranopkgcheck import manager
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/manager.py", line 29, in <module>
    from muranopkgcheck.validators import VALIDATORS
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/validators/__init__.py", line 16, in <module>
    from muranopkgcheck.validators import muranopl
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/validators/muranopl.py", line 19, in <module>
    from muranopkgcheck.checkers import code_structure
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/checkers/code_structure.py", line 18, in <module>
    from muranopkgcheck.checkers import yaql_checker
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/checkers/yaql_checker.py", line 15, in <module>
    import yaql
  File "/usr/lib/python3.10/site-packages/yaql/__init__.py", line 18, in <module>
    from yaql.language import contexts
  File "/usr/lib/python3.10/site-packages/yaql/language/contexts.py", line 20, in <module>
    from yaql.language import runner
  File "/usr/lib/python3.10/site-packages/yaql/language/runner.py", line 20, in <module>
    from yaql.language import expressions
  File "/usr/lib/python3.10/site-packages/yaql/language/expressions.py", line 21, in <module>
    from yaql.language import utils
  File "/usr/lib/python3.10/site-packages/yaql/language/utils.py", line 54, in <module>
    SequenceType = collections.Sequence
AttributeError: module 'collections' has no attribute 'Sequence'

Failed to import test module: muranopkgcheck.tests.test_ui_validator
Traceback (most recent call last):
  File "/usr/lib64/python3.10/unittest/loader.py", line 436, in _find_test_path
    module = self._get_module_from_name(name)
  File "/usr/lib64/python3.10/unittest/loader.py", line 377, in _get_module_from_name
    __import__(name)
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/tests/test_ui_validator.py", line 18, in <module>
    from muranopkgcheck.validators import ui
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/validators/__init__.py", line 16, in <module>
    from muranopkgcheck.validators import muranopl
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/validators/muranopl.py", line 19, in <module>
    from muranopkgcheck.checkers import code_structure
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/checkers/code_structure.py", line 18, in <module>
    from muranopkgcheck.checkers import yaql_checker
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/checkers/yaql_checker.py", line 15, in <module>
    import yaql
  File "/usr/lib/python3.10/site-packages/yaql/__init__.py", line 18, in <module>
    from yaql.language import contexts
  File "/usr/lib/python3.10/site-packages/yaql/language/contexts.py", line 20, in <module>
    from yaql.language import runner
  File "/usr/lib/python3.10/site-packages/yaql/language/runner.py", line 20, in <module>
    from yaql.language import expressions
  File "/usr/lib/python3.10/site-packages/yaql/language/expressions.py", line 21, in <module>
    from yaql.language import utils
  File "/usr/lib/python3.10/site-packages/yaql/language/utils.py", line 54, in <module>
    SequenceType = collections.Sequence
AttributeError: module 'collections' has no attribute 'Sequence'

Failed to import test module: muranopkgcheck.tests.test_yaml_validator
Traceback (most recent call last):
  File "/usr/lib64/python3.10/unittest/loader.py", line 436, in _find_test_path
    module = self._get_module_from_name(name)
  File "/usr/lib64/python3.10/unittest/loader.py", line 377, in _get_module_from_name
    __import__(name)
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/tests/test_yaml_validator.py", line 18, in <module>
    from muranopkgcheck.validators import base
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/validators/__init__.py", line 16, in <module>
    from muranopkgcheck.validators import muranopl
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/validators/muranopl.py", line 19, in <module>
    from muranopkgcheck.checkers import code_structure
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/checkers/code_structure.py", line 18, in <module>
    from muranopkgcheck.checkers import yaql_checker
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/checkers/yaql_checker.py", line 15, in <module>
    import yaql
  File "/usr/lib/python3.10/site-packages/yaql/__init__.py", line 18, in <module>
    from yaql.language import contexts
  File "/usr/lib/python3.10/site-packages/yaql/language/contexts.py", line 20, in <module>
    from yaql.language import runner
  File "/usr/lib/python3.10/site-packages/yaql/language/runner.py", line 20, in <module>
    from yaql.language import expressions
  File "/usr/lib/python3.10/site-packages/yaql/language/expressions.py", line 21, in <module>
    from yaql.language import utils
  File "/usr/lib/python3.10/site-packages/yaql/language/utils.py", line 54, in <module>
    SequenceType = collections.Sequence
AttributeError: module 'collections' has no attribute 'Sequence'

Failed to import test module: muranopkgcheck.validators
Traceback (most recent call last):
  File "/usr/lib64/python3.10/unittest/loader.py", line 470, in _find_test_path
    package = self._get_module_from_name(name)
  File "/usr/lib64/python3.10/unittest/loader.py", line 377, in _get_module_from_name
    __import__(name)
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/validators/__init__.py", line 16, in <module>
    from muranopkgcheck.validators import muranopl
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/validators/muranopl.py", line 19, in <module>
    from muranopkgcheck.checkers import code_structure
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/checkers/code_structure.py", line 18, in <module>
    from muranopkgcheck.checkers import yaql_checker
  File "/builddir/build/BUILD/murano-pkg-check-0.3.0/muranopkgcheck/checkers/yaql_checker.py", line 15, in <module>
    import yaql
  File "/usr/lib/python3.10/site-packages/yaql/__init__.py", line 18, in <module>
    from yaql.language import contexts
  File "/usr/lib/python3.10/site-packages/yaql/language/contexts.py", line 20, in <module>
    from yaql.language import runner
  File "/usr/lib/python3.10/site-packages/yaql/language/runner.py", line 20, in <module>
    from yaql.language import expressions
  File "/usr/lib/python3.10/site-packages/yaql/language/expressions.py", line 21, in <module>
    from yaql.language import utils
  File "/usr/lib/python3.10/site-packages/yaql/language/utils.py", line 54, in <module>
    SequenceType = collections.Sequence
AttributeError: module 'collections' has no attribute 'Sequence'

The deprecated aliases to Collections Abstract Base Classes were removed from the collections module.
https://docs.python.org/3.10/whatsnew/changelog.html#python-3-10-0-alpha-5
https://bugs.python.org/issue37324

For the build logs, see:
https://copr-be.cloud.fedoraproject.org/results/@python/python3.10/fedora-rawhide-x86_64/01952324-python-murano-pkg-check/

For all our attempts to build python-murano-pkg-check with Python 3.10, see:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/package/python-murano-pkg-check/

Testing and mass rebuild of packages is happening in copr. You can follow these instructions to test locally in mock if your package builds with Python 3.10:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/

Let us know here if you have any questions.

Python 3.10 will be included in Fedora 35. To make that update smoother, we're building Fedora packages with early pre-releases of Python 3.10.
A build failure prevents us from testing all dependent packages (transitive [Build]Requires), so if this package is required a lot, it's important for us to get it fixed soon.
We'd appreciate help from the people who know this package best, but if you don't want to work on this now, let us know so we can try to work around it on our side.

Comment 1 Javier Peña 2021-02-09 08:33:36 UTC
Looking at the trace logs, the issue seems to be in the python-yaql package, since murano-pkg-check does not import the collections module. I'll try to get the fix there.

Comment 2 Ben Cotton 2021-02-09 16:08:37 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 34 development cycle.
Changing version to 34.

Comment 3 Joel Capitao 2021-02-22 11:33:02 UTC
(In reply to Javier Peña from comment #1)
> Looking at the trace logs, the issue seems to be in the python-yaql package,
> since murano-pkg-check does not import the collections module. I'll try to
> get the fix there.

I proposed the patch there https://src.fedoraproject.org/rpms/python-yaql/pull-request/6

Comment 4 Miro Hrončok 2021-06-04 20:15:59 UTC
This is a mass-posted update. Sorry if it is not 100% accurate to this bugzilla.


The Python 3.10 rebuild is in progress in a Koji side tag. If you manage to fix the problem, please commit the fix in the rawhide branch, but don't build the package in regular rawhide.

You can either build the package in the side tag, with:

    $ fedpkg build --target=f35-python

Or you can the build and we will eventually build it for you.

Note that the rebuild is still in progress, so not all (build) dependencies of this package might be available right away.

Thanks.

See also https://fedoraproject.org/wiki/Changes/Python3.10

If you have general questions about the rebuild, please use this mailing list thread: https://lists.fedoraproject.org/archives/list/devel@lists.fedoraproject.org/thread/G47SGOYIQLRDTWGOSLSWERZSSHXDEDH5/

Comment 5 Miro Hrončok 2021-06-07 23:00:19 UTC
The f35-python side tag has been merged to Rawhide. From now on, build as you would normally build.

Comment 6 Miro Hrončok 2021-06-08 11:28:53 UTC
*** Bug 1969040 has been marked as a duplicate of this bug. ***

Comment 7 Miro Hrončok 2021-06-15 20:25:22 UTC
Hello,

This is the first reminder (step 3 from https://docs.fedoraproject.org/en-US/fesco/Fails_to_build_from_source_Fails_to_install/#_package_removal_for_long_standing_ftbfs_and_fti_bugs).

If you know about this problem and are planning on fixing it, please acknowledge so by setting the bug status to ASSIGNED. If you don't have time to maintain this package, consider orphaning it, so maintainers of dependent packages realize the problem.

Comment 8 Javier Peña 2021-06-16 07:40:12 UTC
Sorry, I didn't realize the bug was not assigned. I'll try to get https://bugzilla.redhat.com/show_bug.cgi?id=1969311 fixed so we can move on with this one.

Comment 9 Joel Capitao 2021-06-16 08:45:25 UTC
Fixed in https://koji.fedoraproject.org/koji/buildinfo?buildID=1761321


Note You need to log in before you can comment on or make changes to this bug.